import { Route } from "@/routing";
import { isManagerMiddleware } from "@/management/middleware";
import { EditionsManagement } from "@/management/edition/list";
import React from "react";
import { ManagementIndex } from "@/management/main";
import StaticPageManagement from "@/management/page/list";

export const managementRoutes: Route[] = ([
    { name: "index", path: "/", content: ManagementIndex, exact: true },

    { name: "editions", path: "/editions", content: EditionsManagement },
    { name: "static_pages", path: "/static-pages", content: StaticPageManagement }
] as Route[]).map(
    ({ name, path, middlewares = [], ...route }): Route => ({
        name: `management:${ name }`,
        path: `/management${ path }`,
        middlewares: [ isManagerMiddleware, ...middlewares ],
        ...route
    })
);
